<script setup lang="ts">
import { ref } from 'vue';

// Reactive State
const currentPage = ref(1);
const posts = ref([]);
const allPosts = ref([]);
const totalPages = ref(0);
const postsPerPage = 9;
const featuredPost = ref(null);

const { locale } = useI18n();
const { content } = defineProps({
  content: {
    type: Object as never,
    required: true,
  },
});
const targetRef = ref(null);

const { data } = await useAsyncData(async () => {
  const fetchedPosts = await queryContent(locale.value, `/blog/`)
    .where({ 'content.tags': { $contains: content.tag } })
    .sort({ date: -1 })
    .find();

  const totalPosts = fetchedPosts.length;
  const featuredPost = fetchedPosts.shift() || null;
  const totalPagesCount = Math.ceil(totalPosts / postsPerPage);
  const initialPosts = fetchedPosts.slice(0, postsPerPage);

  return {
    allPosts: fetchedPosts,
    featuredPost,
    totalPagesCount,
    initialPosts,
  };
});

allPosts.value = data.value?.allPosts || [];
posts.value = data.value?.initialPosts || [];
totalPages.value = data.value?.totalPagesCount || 0;
featuredPost.value = data.value?.featuredPost || null;

// SEO Metadata
const meta = {
  title: `GitLab Blog tags | ${content.tag}`,
  description: `Browse articles that include the ${content.tag} tag on the GitLab Blog`,
};
useGitlabSeo(meta);

// Page Change Method
const onPageChange = (page: number) => {
  const skip = postsPerPage * (page - 1);
  currentPage.value = page;
  targetRef.value?.scrollIntoView({ behavior: 'smooth' });
  posts.value = allPosts.value.slice(skip, postsPerPage * page);
};
</script>

<template>
  <div ref="targetRef">
    <BlogCategoryHero v-if="content.tag" :label="content.tag" variant="tag" />
    <BlogCategoryFeaturedPost v-if="featuredPost" :post="featuredPost" />
    <BlogPostGrid v-if="posts.length" :posts="posts" />
    <BlogPagination :total-pages="totalPages" :current-page="currentPage" @page-change="onPageChange" />
    <BlogHomeNewsLetterForm />
    <CommonGetStarted class="slp-mt-64" />
  </div>
</template>

<style lang="scss" scoped>
.featured-post {
  display: flex;
  gap: 32px;
  margin: 48px 0;
  flex-direction: column;
  background: $color-surface-800;
  border-radius: 0 0 80px 0;

  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }

  .text {
    padding: 40px 32px 40px 8px;
    display: flex;
    flex-direction: column;
    gap: 16px;

    .author {
      flex-basis: 100%;
    }

    .cta {
      inline-size: max-content;
    }
  }

  .image img {
    flex-shrink: 0;
    width: 100%;

    @media (min-width: $breakpoint-lg) {
      width: 560px;
      height: 100%;
      object-fit: cover;
    }
  }
}
</style>
